import { Observable } from 'rxjs';
export declare class StateStore<T> {
    private destroy$;
    private _value$;
    value$: Observable<T>;
    get value(): T;
    constructor(initialValue: T);
    destroy(): void;
    update(value: T): void;
    /**
     * Patch an object value
     */
    patch(partialValue: Partial<T>): T;
    /**
     * Remove an item from an array by id
     */
    removeItemById(id: unknown): void;
    /**
     * Remove an item from an array
     */
    removeItem(item: Record<any, unknown>): void;
    /**
     * Update an item in an array
     */
    updateItem(item: Record<any, unknown>): void;
    /**
     * Add an item to an array
     */
    addItem(item: Record<any, unknown>): void;
    private isObject;
}
